// Sample.c :
//
#include <windows.h>
#include <stdio.h>
#include <string.h>

int main(int argc, char* argv[])
{

  char mModule[256], mMBox[256], mSrc[256], mOption[256];
  HMODULE hDLL;
  FARPROC lpfnDll;    // Function pointer
  BOOL    bsts;

  if (argc < 4)
	return -1;
  //////////////////////////////////////////////////
  // Option1. found DLL module.
  // strcpy(mModule, "debug\\test.dll");
  strcpy(mModule, argv[1]);
  if (mModule[0] == '\x0') {
	return -1;
  }
  //////////////////////////////////////////////////
  // Option2. found mailbox folder
  strcpy(mMBox, argv[2]);
  if (mMBox[0] == '\x0') {
	return -1;
  }
  //////////////////////////////////////////////////
  // Option3. found Soruce folder & mail message file.
  strcpy(mSrc, argv[3]);
  if (mSrc[0] == '\x0') {
	return -1;
  }
  //////////////////////////////////////////////////
  // Option4. found option folder.
  strcpy(mOption, argv[4]);
  if (mOption[0] == '\x0') {
	return -1;
  }
  /////////////////////////////////////////////////
  // Set DLL module.
  hDLL = LoadLibrary(mModule); 
  if (hDLL) {
    lpfnDll = GetProcAddress(hDLL, "MessageProc"); // Opening DLL module.
	if (lpfnDll)
      bsts = lpfnDll(mMBox, mSrc, mOption); // executing.
	else
	  printf("not found MessageProc() process. MessageProc()\n");

    FreeLibrary(hDLL); // Closeing DLL module.
  } else {
	printf("not found module name. (%s)\n", mModule);
  }

  return 0;
}
